<template>
  <!-- 查询和其他操作 -->
  <div class="filter-container" style="margin: 10px 0 10px 0;">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="用户来源">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="用户来源"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="用户ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.openId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="瓦力ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.uid" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="会员状态">
        <el-select v-model="queryParams.isVip" placeholder="会员状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="会员" value="1">会员</el-option>
          <el-option label="非会员" value="0">非会员</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="订单号">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.requestId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="首存状态">
        <el-select v-model="queryParams.isFirstDep" placeholder="首存状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="首存" value="1">首存</el-option>
          <el-option label="非首存" value="2">非首存</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="订单状态">
        <el-select v-model="queryParams.orderStatus" placeholder="订单状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="未完成" value="0">未完成</el-option>
          <el-option label="已完成" value="1">已完成</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="datetime"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="datetime"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>
    <div style="margin: 10px 10px 10px 10px;">
      <span>充值总金额:</span>
      <el-input type="number"  style="width: 150px;"  v-model="sumAmount"  readonly="readonly"/>
      <span>充值用户总数:</span>
      <el-input type="number"  style="width: 100px;"  v-model="totalTimes" readonly="readonly"/>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="订单号" style="width:10%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.requestId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="时间" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户来源" style="width:15%" :show-overflow-tooltip="true" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.sourceName }}</span>
          </template>
      </el-table-column>
      <el-table-column label="会员状态" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isVip == 1">会员</span>
          <span v-if="scope.row.isVip == 0 || scope.row.isVip == ''">非会员</span>
        </template>
      </el-table-column>
      <el-table-column label="会员类型" style="width:2%" :show-overflow-tooltip="true"  align="center" prop="vipLevel">
        <template slot-scope="scope">
          <span>{{ scope.row.vipType }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.openId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户昵称" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.loginName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="是否为首存" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isFirstDepShow == 1">首存</span>
          <span v-if="scope.row.isFirstDepShow == 2">非首存</span>
        </template>
      </el-table-column>
      <el-table-column label="瓦力ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.cusUid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="充值金额" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.amount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="充值获取金币" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.coins }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" style="width:5%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.flag == 0">未付款</span>
          <span v-if="scope.row.flag == 1">已付款</span>
          <span v-if="scope.row.flag == 2">已上分</span>
        </template>
      </el-table-column>
      <el-table-column label="原因" style="width:10%" :show-overflow-tooltip="true" align="center">
      </el-table-column>


    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import {dateFormat} from "@/utils/webUtils.js";
import {getOrderRequestList,getDepositTotal,getSourceList} from "@/api/depositRequest";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";
  export default {
    data() {
      return {
        sourceData: [
          {
            name:'全选',
            source:''}
        ],
        queryParams:{//查询参数
          requestId: "",//订单ID
          openId: "", //用户ID
          beginCreateTime: dateFormat("YYYY-mm-dd 00", new Date()),
          endCreateTime: dateFormat("YYYY-mm-dd 23", new Date()),
          orderStatus: "", //订单状态
            source: "",
            uid: "",
            isFirstDepShow: "",
          isVip: "",
        },
        tableData: [],
          sumAmount: 0,
          totalTimes: 0,
        currentPage: 1,
        pageSize: 40,
        total: 0, //总数量
        orderByDescColumn: "", // 降序字段
        orderByAscColumn: "", // 升序字段
        form: {
          content: "",
          introduce: "",
          sort: 0,
        },
      };
    },

    created() {
      this.orderRequestList();
      this.sourceList();

    },
    methods: {
      sourceList: function() {
        var sourceParams = {};
        sourceParams.pageSize = 1000;
        sourceParams.currentPage = 1;
        getSourceList(sourceParams).then(response => {
          this.sourceData.push(...response.data.records);
        });
      },
      orderRequestList: function() {
        this.queryParams.currentPage = this.currentPage;
        this.queryParams.pageSize = this.pageSize;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getOrderRequestList(this.queryParams).then(response => {
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        });
        getDepositTotal(this.queryParams).then(response =>{
              this.sumAmount = response.data.sumAmount;
              this.totalTimes = response.data.totalTimes;
          });
      },
      getFormObject: function() {
        var formObject = {
          uid: null,
          content: null,
          clickCount: 0,
          sort: 0
        };
        return formObject;
      },
      handleFind: function() {
        this.currentPage = 1
        this.orderRequestList();
      },
      handleSizeChange(val) {
        this.pageSize = val;
        this.orderRequestList();
      },
      handleCurrentChange: function(val) {
        this.currentPage = val;
        this.orderRequestList();
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleClose(){
        this.dialogFormVisible = false;
        this.orderRequestList();
      },
      // 导出excel数据
      exportData() {
        // 表头对应关系
        const headers = {
          '订单号': 'requestId',
          '时间': 'createTime',
          '用户来源': 'sourceName',
          '会员状态': 'isVip',
          '会员类型': 'vipType',
          '用户ID': 'openId',
          '用户昵称': 'loginName',
          '是否为首存': 'isFirstDepShow',
          '瓦力ID': 'cusUid',
          '充值金额': 'amount',
          '充值获取金币': 'coins',
          '状态': 'flag',
        }
        this.queryParams.currentPage = 1;
        this.queryParams.pageSize = -1;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getOrderRequestList(this.queryParams).then(response => {
          const data = this.formatJson(headers, response.data.records)
          export_json_to_excel(Object.keys(headers), data, '充值订单列表')
        });
      },
      // 该方法负责将数组转化成二维数组
      formatJson(headers, rows) {
        // 首先遍历数组
        return rows.map(item => {
          return Object.keys(headers).map(key => {
            if (headers[key] === 'flag') {
              if(item[headers[key]] === 0){
                return '未付款';
              } else if(item[headers[key]] === 1) {
                return '已付款';
              } else if(item[headers[key]] === 2){
                return '已上分';
              }
            }else if((headers[key] === 'isFirstDepShow')){
              if(item[headers[key]] === 1) {
                return '首存';
              } else if(item[headers[key]] === 2){
                return '非首存';
              }else{
                return '';
              }
            }else if((headers[key] === 'isVip')){
              if(item[headers[key]] ===1){
                return '会员';
              }else{
                return '非会员';
              }
            }
            return item[headers[key]]
          })
        })
      },
      vipLevelFomatt: function (row, column) {
            if(row.vipLevel !=""){
                return  'VIP'+row.vipLevel;
            }else{
                return  'VIP0';
            }
        },
    }
  };
</script>

<style scoped>

</style>
